## phcpack 2.4.92+dfsg

=== src/doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) source

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/PHCpack.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/PHCpack.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/PHCpack"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/PHCpack"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== debian/changelog ===
phcpack (2.4.92+dfsg-2) unstable; urgency=medium

  * debian/control
    - Remove redundant Rules-Requires-Root field.
    - Remove Priority field since "optional" is now the default.
    - Bump Standards-Version to 4.7.3.
    - Add dh-octave to Build-Depends.  This is redundant since we're
      already depending on dh-sequence-octave, but it's harmless and
      silences a false positive Lintian error
      (missing-build-dependency-for-dh_-command).
  * debian/copyright
    - Update my copyright years.
    - Update years for documentation license information and include PHCpy
      directory.
  * debian/rules
    - Set PYBUILD_SYSTEM since pybuild cannot detect the build system.
    - Stop injecting "-std=gnu++14" build flag; issue fixed upstream.

 -- Doug Torrance <dtorrance@debian.org>  Tue, 20 Jan 2026 11:07:29 -0500

phcpack (2.4.92+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 07 Nov 2025 22:56:42 -0500

=== debian/control ===
Source: phcpack
Section: math
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-octave,
               dh-sequence-octave,
               dh-sequence-sphinxdoc <!nodoc>,
               dvipng <!nodoc>,
               python3-sphinx,
               texlive-latex-base <!nodoc>,
               texlive-latex-extra <!nodoc>
Build-Depends-Arch: dh-ada-library (>= 8.2),
                    dh-sequence-python3 <!nopython>,
                    gnat (>= 11~),
                    gprbuild,
                    python3-all-dev <!nopython>,
                    python3-setuptools <!nopython>,
                    python3-tk <!nopython>
Standards-Version: 4.7.3
Homepage: https://homepages.math.uic.edu/~jan/PHCpack/phcpack.html
Vcs-Browser: https://salsa.debian.org/math-team/phcpack
Vcs-Git: https://salsa.debian.org/math-team/phcpack.git

Package: phcpack
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: phcpack-doc (= ${source:Version})
Suggests: macaulay2, octave-phclab (= ${source:Version})
Description: general-purpose solver for polynomial systems (command line)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains the command line interface to PHCpack.

Package: phcpack-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nodoc>
Description: general-purpose solver for polynomial systems (documentation)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains demo files and documentation.

Package: python3-phcpy
Section: python
Architecture: any
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Build-Profiles: <!nopython>
Description: general-purpose solver for polynomial systems (Python)
 PHCpack is a software package to solve polynomial systems by homotopy
 continuation methods.
 .
 A polynomial system is given as a sequence of polynomials in several
 variables.  Homotopy continuation methods operate in two stages. In
 the first stage, a family of polynomial systems (the so-called
 homotopy) is constructed. This homotopy contains a polynomial system
 with known solutions. In the second stage, numerical continuation
 methods are applied to track the solution paths defined by the
 homotopy, starting at the known solutions and leading to the solutions
 of the given polynomial system.
 .
 This package contains PHCpy, the Python interface to PHCpack.

Package: octave-phclab
Architecture: all
Depends: phcpack (>= ${source:Version}), ${misc:Depends}, ${octave:Depends}
Description: general-purpose solver for polynomial systems (Octave)
 ${octave:Upstream-Description}

=== debian/rules ===
#!/usr/bin/make -f

command = $(shell /bin/sh -c "command -v $(1)")

ifneq (,$(call command, pybuild))
DH_OPTIONS += --buildsystem=pybuild
PYBUILD_BUILD_DIRS := $(shell pybuild --system distutils --print {build_dir})
export PYBUILD_SYSTEM = distutils
endif

%:
	dh $@ $(DH_OPTIONS)

# With gcc-11 -fstack-protector-strong:
# gnatbind -n -static use_c2phc -o use_c2phc_binder.adb
# raised STORAGE_ERROR : stack overflow or erroneous memory access
DEB_BUILD_MAINT_OPTIONS = hardening=+all,-stackprotectorstrong optimize=-lto

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# This line has no effect during architecture-independent builds:
include $(wildcard /usr/share/ada/packaging.mk)

export PYBUILD_DIR = src/Python/PHCpy

override_dh_auto_build-arch:
	@echo "+------------------+"
	@echo "| building PHCpack |"
	@echo "+------------------+"
	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/main.gpr
	$(MAKE) -C src/doc man
ifeq (,$(filter nopython, $(DEB_BUILD_PROFILES)))
	@echo "+----------------+"
	@echo "| building PHCpy |"
	@echo "+----------------+"
	mv src/bin/phc src/bin/phc.bak
	cd src/Ada/Main && gprclean main.gpr # so we can recompile with -fPIC
	mv src/bin/phc.bak src/bin/phc
	gprbuild $(GPRBUILDFLAGS) src/Ada/Main/phclib.gpr
	pybuild --build
	cp src/lib/libPHCpack.so $(PYBUILD_DIR) # for building docs
	for dir in $(PYBUILD_BUILD_DIRS);        \
		do cp src/lib/libPHCpack.so $$dir; \
	done
ifeq (,$(filter nodoc, $(DEB_BUILD_PROFILES)))
	@echo "+---------------------+"
	@echo "| building PHCpy docs |"
	@echo "+---------------------+"
	$(MAKE) -C src/Python/PHCpy/doc html
endif
endif

ifeq (,$(filter nodoc, $(DEB_BUILD_PROFILES)))
override_dh_auto_build-indep:
	@echo "+-----------------------+"
	@echo "| building PHCpack docs |"
	@echo "+-----------------------+"
	$(MAKE) -C src/doc html
endif

# skip upstream test suite for now
# https://github.com/janverschelde/PHCpack/issues/41
# override_dh_auto_test:
#	$(MAKE) -C src/Objects testall

execute_before_dh_octave_version: DESCRIPTION

execute_before_dh_auto_install-indep: DESCRIPTION
	@echo "+-----------------+"
	@echo "| building PHClab |"
	@echo "+-----------------+"

	cp --update --reflink=auto src/Octave/COPYING.txt COPYING

	mkdir --parents inst
	cp --update --reflink=auto src/Octave/*.m debian/PKG_ADD inst

	dh_auto_install --buildsystem=octave

override_dh_octave_check-arch:

include /usr/share/dpkg/pkg-info.mk
DESCRIPTION: debian/DESCRIPTION.in
	sed -e "s/@VERSION@/$(DEB_VERSION_UPSTREAM)/" \
	    -e "s/@DATE@/$(shell date -u -I -d@$(SOURCE_DATE_EPOCH))/" $< > $@

override_dh_dwz:
# avoid the following:
# dwz: ./dwz.c:12035: adjust_exprloc: Assertion `refd != NULL &&
#   !refd->die_remove' failed.

override_dh_octave_substvar:
	dh_octave_substvar -poctave-phclab

override_dh_clean:
	dh_clean -Xbak

execute_after_dh_auto_clean:
	gprclean src/Ada/Main/main.gpr || true
	gprclean src/Ada/Main/phclib.gpr || true
	$(MAKE) -C src/Python/PHCpy/doc clean
	$(MAKE) -C src/doc clean
	dh_auto_clean --buildsystem=octave || true
